package com.diagbot.entity.node;

import com.diagbot.biz.push.entity.Pacs;
import com.diagbot.entity.node.base.BaseNode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "年龄")
public class Age extends BaseNode  {

	@Property(name = "最小值")
	private Double minval;

	@Property(name = "最大值")
	private Double maxval;

	@Property(name = "范围")
	private Integer range;

	@Property(name = "名称")
	private String termname;

	@Relationship(type = "药品通用名称禁忌年龄", direction = Relationship.INCOMING)
	private Set<Medicine> medicines = new HashSet<>();

}