package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.Set;
import java.util.HashSet;

@Setter
@Getter
@NodeEntity(label = "联合项目")
public class CombiOperation extends BaseNode  {


	@Property(name = "联合操作")
	private String combi_name;

	@Relationship(type = "联合项目禁忌实验室检查", direction = Relationship.OUTGOING)
	private Set<Lis> liss = new HashSet<>();

	@Relationship(type = "联合项目禁忌辅助检查名称描述", direction = Relationship.OUTGOING)
	private Set<PacsDescribe> pacsdescs = new HashSet<>();

	@Relationship(type = "联合项目禁忌疾病", direction = Relationship.OUTGOING)
	private Set<Disease> diseases = new HashSet<>();

	@Relationship(type = "联合项目禁忌禁忌人群", direction = Relationship.OUTGOING)
	private Set<Group> groups = new HashSet<>();

	@Relationship(type = "联合项目禁忌药物过敏原", direction = Relationship.OUTGOING)
	private Set<MedAllergen> medallergens = new HashSet<>();

	@Relationship(type = "联合项目禁忌性别", direction = Relationship.OUTGOING)
	private Gender gender;

}