package com.diagbot.entity.node;

import com.diagbot.biz.push.entity.Pacs;
import com.diagbot.entity.node.base.BaseNode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "实验室检查")
public class Lis extends BaseNode  {

	@Property(name = "单位")
	private String unit;

	@Property(name = "最小值")
	private Double minval;

	@Property(name = "最大值")
	private Double maxval;

	@Property(name = "范围")
	private Integer range;

	@Relationship(type = "医保手术和操作名称禁忌实验室检查", direction = Relationship.INCOMING)
	private Set<YiBaoOperationName> yibaooperationnames = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌实验室检查", direction = Relationship.INCOMING)
	private Set<Pacs> pacss = new HashSet<>();

	@Relationship(type = "联合项目禁忌实验室检查", direction = Relationship.INCOMING)
	private Set<CombiOperation> combioperations = new HashSet<>();

//	@Relationship(type = "辅助检查禁忌实验室检查", direction = Relationship.INCOMING)
//	private Set<Pacs> pacss = new HashSet<>();

	@Relationship(type = "医保手术和操作禁忌实验室检查", direction = Relationship.INCOMING)
	private Set<YiBaoOperation> yibaooperations = new HashSet<>();

}