package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Property;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "实验室检查结果")
public class LisResult extends BaseNode  {

	@Property(name = "单位")
	private String unit;

	@Property(name = "最小值")
	private Double minval;

	@Property(name = "最大值")
	private Double maxval;

	@Property(name = "范围")
	private Integer range;

	@Property(name = "性别")
	private String gender;

	@Property(name = "年龄最大值")
	private Integer maxage;

	@Property(name = "年龄最小值")
	private Integer minage;

	@Relationship(type = "实验室检查结果相关医保疾病名称", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseName> disease = new HashSet<>();

}