package com.diagbot.entity.node;

import com.diagbot.entity.node.base.BaseNode;
import lombok.Getter;
import lombok.Setter;
import org.neo4j.ogm.annotation.NodeEntity;
import org.neo4j.ogm.annotation.Relationship;

import java.util.HashSet;
import java.util.Set;

@Setter
@Getter
@NodeEntity(label = "辅助检查名称")
public class PacsName extends BaseNode  {


	@Relationship(type = "辅助检查名称包含辅助检查子项目名称", direction = Relationship.OUTGOING)
	private Set<PacsSubName> pacssubnames = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌性别", direction = Relationship.OUTGOING)
	private Gender gender;

	@Relationship(type = "辅助检查名称禁忌临床表现", direction = Relationship.OUTGOING)
	private Set<ClinicalFinding> clinicalfindings = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌体征", direction = Relationship.OUTGOING)
	private Set<Vital> vitals = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌实验室检查", direction = Relationship.OUTGOING)
	private Set<Lis> lis = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌辅助检查名称描述", direction = Relationship.OUTGOING)
	private Set<PacsDescribe> pacsdescribes = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌禁忌人群", direction = Relationship.OUTGOING)
	private Set<Group> groups = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌服用药品", direction = Relationship.OUTGOING)
	private Set<OralMedicine> oralmedicines = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌药物过敏原", direction = Relationship.OUTGOING)
	private Set<MedAllergen> medallergens = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌疾病", direction = Relationship.OUTGOING)
	private Set<Disease> diseases = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌过敏原", direction = Relationship.OUTGOING)
	private Set<Allergen> allergens = new HashSet<>();

	@Relationship(type = "辅助检查名称禁忌禁忌医疗器械及物品", direction = Relationship.OUTGOING)
	private Set<ConflictDevice> conflictdevices = new HashSet<>();

	@Relationship(type = "辅助检查名称相关医保疾病名称", direction = Relationship.OUTGOING)
	private Set<YiBaoDiseaseName> disease = new HashSet<>();
}