package com.diagbot.facade;

import com.diagbot.enums.RedisEnum;
import com.diagbot.enums.StandConvertEnum;
import com.diagbot.util.RedisUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.stereotype.Component;

/**
 * @Description:
 * @Author:zhoutg
 * @time: 2018/11/23 11:37
 */
@Component
public class CacheFacade {

    @Autowired
    RedisUtil redisUtil;

    /**
     * 清除缓存信息
     *
     * @return
     */
    @CacheEvict(value = "cache", allEntries = true)
    public void clear() {

    }

    /**
     * 清除标准词转换缓存信息
     *
     * @return
     */
    public void clearStandConvert() {
        redisUtil.delete(StandConvertEnum.disease.getName());
        redisUtil.delete(StandConvertEnum.drug.getName());
        redisUtil.delete(StandConvertEnum.lis.getName());
        redisUtil.delete(StandConvertEnum.operation.getName());
        redisUtil.delete(StandConvertEnum.pacs.getName());
        redisUtil.delete(StandConvertEnum.symptom.getName());
        redisUtil.delete(StandConvertEnum.vital.getName());
        redisUtil.delete(StandConvertEnum.transfusion.getName());
    }

    /**
     * 清除启动加载类缓存
     *
     * @return
     */
    public void clearLoadCache() {
        redisUtil.deleteByPrex(RedisEnum.drugType.getName());
    }
}
