package com.diagbot.facade;

import com.diagbot.biz.push.entity.Item;
import com.diagbot.dto.HighRiskNeoDTO;
import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.HighRiskProcess;
import com.diagbot.vo.HighRiskNeoVO;
import com.diagbot.vo.IndicationPushVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Description: 高风险合理性facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class HighRiskFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    HighRiskProcess highRiskProcess;
    @Autowired
    CommonFacade commonFacade;

    /**
     * 高风险提示
     * @param
     * @return
     */
    public void highRiskFac(IndicationPushVO indicationPushVO, WordCrfDTO wordCrfDTO, IndicationDTO res) {
        // 高风险图谱接口调用
        // HighRiskNeoVO highRiskNeoVO = fillHighRiskNeo(wordCrfDTO);
        List<HighRiskNeoDTO> highRiskNeoDTOList = neoFacade.getHighRiskNeo(wordCrfDTO);
        // 规则处理
        // TODO 测试数据开始
        // HighRiskNeoDTO highRiskNeoDTO = new HighRiskNeoDTO();
        // highRiskNeoDTO.setIsHighrisk(false);
        // highRiskNeoDTO.setName("锁骨下动脉药物洗脱支架置入术");
        // highRiskNeoDTO.setStandname("锁骨下动脉药物洗脱支架置入术");
        // highRiskNeoDTO.setType("手术");
        // List<NodeNeoDTO> factor = highRiskNeoDTO.getFactor();
        // NodeNeoDTO nodeNeo = new NodeNeoDTO();
        // nodeNeo.setTermtype("诊断");
        // nodeNeo.setName("急性胰腺炎");
        // factor.add(nodeNeo);
        // NodeNeoDTO nodeLis = new NodeNeoDTO();
        // nodeLis.setTermtype("化验");
        // nodeLis.setName("白细胞计数");
        // nodeLis.setMax(new BigDecimal(20));
        // nodeLis.setMin(new BigDecimal(10));
        // nodeLis.setValType(0);
        // factor.add(nodeLis);
        // NodeNeoDTO nodeLis1 = new NodeNeoDTO();
        // nodeLis1.setTermtype("化验");
        // nodeLis1.setName("红细胞压积");
        // nodeLis1.setVal("阳性");
        // factor.add(nodeLis1);
        //
        // NodeNeoDTO nodePass = new NodeNeoDTO();
        // nodePass.setTermtype("辅检");
        // nodePass.setName("胸部CT");
        // nodePass.setVal("肺叶根治性切除标本");
        // factor.add(nodePass);
        // NodeNeoDTO vital = new NodeNeoDTO();
        // vital.setName("体温");
        // vital.setMax(new BigDecimal("39.1"));
        // vital.setMin(new BigDecimal("35.1"));
        // vital.setValType(1);
        // vital.setTermtype("查体");
        // factor.add(vital);
        // //
        // NodeNeoDTO vitalBp = new NodeNeoDTO();
        // vitalBp.setName("意识模糊");
        // vitalBp.setValType(1);
        // vitalBp.setVal("意识模糊");
        // vitalBp.setTermtype("查体");
        // factor.add(vitalBp);
        //
        // NodeNeoDTO vitalBp2 = new NodeNeoDTO();
        // vitalBp2.setName("年龄");
        // vitalBp2.setMax(new BigDecimal("1"));
        // vitalBp2.setMin(new BigDecimal("18"));
        // vitalBp2.setValType(1);
        // vitalBp2.setTermtype("年龄");
        // factor.add(vitalBp2);
        //
        // highRiskNeoDTOList.add(highRiskNeoDTO);
        // TODO 测试数据结束
        highRiskProcess.process(highRiskNeoDTOList, res,wordCrfDTO);

        // 结果去重处理
        // commonFacade.dealMsg(res.getHighRiskList());
    }


    public HighRiskNeoVO fillHighRiskNeo(WordCrfDTO wordCrfDTO) {
        HighRiskNeoVO highRiskNeoVO = new HighRiskNeoVO();

        highRiskNeoVO.getDrugList().addAll(wordCrfDTO.getDrugOrder());

        List<Item> items = wordCrfDTO.getOperationOrder();

        for (Item item : items) {
            highRiskNeoVO.getOperationList().put(item.getName(), item.getUniqueName());
        }


        return highRiskNeoVO;
    }
}
