package com.diagbot.facade;

import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.OtherTipNeoDTO;
import com.diagbot.dto.OtherTipPacsNeoDTO;
import com.diagbot.dto.OtherTipTransfusionNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.OtherTipProcess;
import com.diagbot.vo.IndicationPushVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description: 其他提示facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class OtherTipFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    OtherTipProcess otherTipProcess;
    @Autowired
    CommonFacade commonFacade;

    /**
     * 其他提示
     *
     * @param
     * @return
     */
    public void otherTipFac(IndicationPushVO indicationPushVO, WordCrfDTO wordCrfDTO, IndicationDTO res) {
        List<OtherTipNeoDTO> otherTipNeoDTOList = neoFacade.getOtherRemind(wordCrfDTO.getLis());
        // 其他提示——化验
        // // TODO 测试数据开始
        // OtherTipNeoDTO otherTipNeoDTO = new OtherTipNeoDTO();
        // otherTipNeoDTO.setName("血常规");
        // otherTipNeoDTO.setDetailName("血葡萄糖测定");
        // otherTipNeoDTO.setValue(20.0D);
        // List<NodeNeoDTO> factor = new ArrayList<>();
        // NodeNeoDTO nodeNeoDTO = new NodeNeoDTO();
        // // otherTipNeoDTO.setOtherValue("阳性");
        // nodeNeoDTO.setName("急性胰腺炎");
        // nodeNeoDTO.setTermtype("诊断");
        // factor.add(nodeNeoDTO);
        // otherTipNeoDTO.setFactor(factor);
        // otherTipNeoDTOList.add(otherTipNeoDTO);
        //
        // OtherTipNeoDTO otherTipNeoDTO2 = new OtherTipNeoDTO();
        // otherTipNeoDTO2.setName("血生化检查");
        // otherTipNeoDTO2.setDetailName("血肌酐测定");
        // otherTipNeoDTO2.setValue(200.0);
        // List<NodeNeoDTO> factor2 = new ArrayList<>();
        // NodeNeoDTO nodeNeoDTO2 = new NodeNeoDTO();
        // nodeNeoDTO2.setName("坦洛新");
        // nodeNeoDTO2.setTermtype("药品");
        // factor2.add(nodeNeoDTO2);
        // otherTipNeoDTO2.setFactor(factor2);
        // otherTipNeoDTOList.add(otherTipNeoDTO2);
        // // TODO 测试数据结束
        otherTipProcess.processLis(otherTipNeoDTOList, wordCrfDTO, res);

        // 其他提示——建议输血
        List<OtherTipTransfusionNeoDTO> otherTipTransfusionNeoDTOList = neoFacade.getRecommendTransfs(wordCrfDTO);
        // TODO 测试数据开始
        // // 化验 + 诊断
        // OtherTipTransfusionNeoDTO otherTipTransfusionNeoDTO = new OtherTipTransfusionNeoDTO();
        // otherTipTransfusionNeoDTO.setName("血小板");
        // List<Lis> lisList = new ArrayList<>();
        // Lis lis1 = new Lis();
        // lis1.setValue(30.0);
        // // lis1.setOtherValue("阳性");
        // lis1.setName("血常规");
        // lis1.setDetailName("血小板计数");
        // lisList.add(lis1);
        // otherTipTransfusionNeoDTO.setLisList(lisList);
        // List<Item> diag = new ArrayList<>();
        // Item item = new Item();
        // item.setName("败血症");
        // item.setUniqueName("败血症");
        // diag.add(item);
        // otherTipTransfusionNeoDTO.setDiag(diag);
        // otherTipTransfusionNeoDTOList.add(otherTipTransfusionNeoDTO);
        //
        // // 化验 + 手术
        // OtherTipTransfusionNeoDTO otherTipTransfusionNeoDTO2 = new OtherTipTransfusionNeoDTO();
        // otherTipTransfusionNeoDTO2.setName("血小板");
        // List<Lis> lisList2 = new ArrayList<>();
        // Lis lis2 = new Lis();
        // lis2.setValue(30.0);
        // // lis2.setOtherValue("阳性");
        // lis2.setName("血常规");
        // lis2.setDetailName("血小板计数");
        // lisList2.add(lis2);
        // otherTipTransfusionNeoDTO2.setLisList(lisList2);
        // List<Item> operation = new ArrayList<>();
        // Item item2 = new Item();
        // item2.setName("咽鼓管置管术");
        // item2.setUniqueName("咽鼓管置管术");
        // operation.add(item2);
        // otherTipTransfusionNeoDTO2.setOperation(operation);
        // otherTipTransfusionNeoDTOList.add(otherTipTransfusionNeoDTO2);
        //
        // // 化验 + 辅检名称
        // OtherTipTransfusionNeoDTO otherTipTransfusionNeoDTO3 = new OtherTipTransfusionNeoDTO();
        // otherTipTransfusionNeoDTO3.setName("血小板");
        // List<Lis> lisList3 = new ArrayList<>();
        // Lis lis3 = new Lis();
        // lis3.setValue(30.0);
        // // lis2.setOtherValue("阳性");
        // lis3.setName("血常规");
        // lis3.setDetailName("血小板计数");
        // lisList3.add(lis3);
        // otherTipTransfusionNeoDTO3.setLisList(lisList3);
        // List<Item> pacs = new ArrayList<>();
        // Item item3 = new Item();
        // item3.setName("直视下支气管活检术");
        // item3.setUniqueName("直视下支气管活检术");
        // pacs.add(item3);
        // otherTipTransfusionNeoDTO3.setPacs(pacs);
        // otherTipTransfusionNeoDTOList.add(otherTipTransfusionNeoDTO3);
        //
        // // 化验 + 辅检结果
        // OtherTipTransfusionNeoDTO otherTipTransfusionNeoDTO4 = new OtherTipTransfusionNeoDTO();
        // otherTipTransfusionNeoDTO4.setName("血小板");
        // List<Lis> lisList4 = new ArrayList<>();
        // Lis lis4 = new Lis();
        // lis4.setValue(30.0);
        // // lis2.setOtherValue("阳性");
        // lis4.setName("血常规");
        // lis4.setDetailName("血小板计数");
        // lisList4.add(lis4);
        // otherTipTransfusionNeoDTO4.setLisList(lisList4);
        // List<Item> pacsRes = new ArrayList<>();
        // Item item4 = new Item();
        // item4.setName("MA 值降低伴有明显出血");
        // item4.setUniqueName("MA 值降低伴有明显出血");
        // pacsRes.add(item4);
        // otherTipTransfusionNeoDTO4.setPacsRes(pacsRes);
        // otherTipTransfusionNeoDTOList.add(otherTipTransfusionNeoDTO4);

        // TODO 测试数据结束
        otherTipProcess.processTransfusion(otherTipTransfusionNeoDTOList, res);

        // 其他提示——辅检
        List<OtherTipPacsNeoDTO> otherTipPacsNeoDTOList = neoFacade.getPacsReminds(wordCrfDTO);
        // TODO 测试数据开始
        // OtherTipPacsNeoDTO otherTipPacsNeoDTO = new OtherTipPacsNeoDTO();
        // otherTipPacsNeoDTO.setMsg("该患者年龄在18-60岁，主胰管内径≥3mm，可考虑主胰管扩张");
        // otherTipPacsNeoDTOList.add(otherTipPacsNeoDTO);
        // TODO 测试数据结束
        otherTipProcess.processPacs(otherTipPacsNeoDTOList, res);
    }

}
