package com.diagbot.repository;

import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.CombiOpBillNeoDTO;
import com.diagbot.entity.node.*;
import com.diagbot.util.ListUtil;
import com.diagbot.util.NeoUtil;

import java.util.*;

public class CombiOperationNode {

	public CombiOpBillNeoDTO CombiOptoCombiOpDTO(CombiOperation combiOp) {

		CombiOpBillNeoDTO combiOpBillNeoDTO = new CombiOpBillNeoDTO();
		NodeInfo nodeInfo;


		Gender gender = combiOp.getGender();
		if (null!=gender) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(gender.getName());
			nodeInfo.setTypeval(Constants.gender);
			combiOpBillNeoDTO.setGender(NeoUtil.updateNodeInfo(nodeInfo));
		}


		Set<Group> groups = combiOp.getGroups();
		for (Group group : groups) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(group.getName());
			nodeInfo.setTypeval(Constants.group);
			combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
		}


		Set<Lis> lislist = combiOp.getLiss();
		for (Lis lis : lislist) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(lis.getName());
			nodeInfo.setTypeval(Constants.lis);
			combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
		}


		Set<PacsDescribe> pacsDescribes = combiOp.getPacsdescs();
		for (PacsDescribe pacsdesc : pacsDescribes) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(pacsdesc.getName());
			nodeInfo.setTypeval(Constants.pacsdesc);
			combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
		}


		Set<Disease> diseases = combiOp.getDiseases();
		for (Disease dis : diseases) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(dis.getName());
			nodeInfo.setTypeval(Constants.disease);
			combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
		}


		Set<MedAllergen> medAllergens = combiOp.getMedallergens();
		for (MedAllergen medallergen : medAllergens) {
			nodeInfo = new NodeInfo();
			nodeInfo.setName(medallergen.getName());
			nodeInfo.setTypeval(Constants.medallergen);
			combiOpBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
		}



		return combiOpBillNeoDTO;
	}


	/**
	 * 获取联合项目开单合理性
	 */
	public List<BillNeoDTO> getCombiOpBill(Map<String, String> combiterm, CombiOperationRepository combiRepository) {

		List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
		BillNeoDTO billNeoDTO;

		CombiOpBillNeoDTO combiOpBillNeoDTO;

		List<CombiOperation> oplist;
		String opname;

		for (String term : combiterm.keySet()) {
			billNeoDTO = new BillNeoDTO();
			opname = combiterm.get(term);
			billNeoDTO.setName(term);
			billNeoDTO.setStandname(opname);

			oplist = combiRepository.findByNameIs(opname);

			if (ListUtil.isNotEmpty(oplist)) {
				combiOpBillNeoDTO = CombiOptoCombiOpDTO(oplist.get(0));

				billNeoDTO.setCombiOpBillNeoDTO(combiOpBillNeoDTO);

				billNeoDTOs.add(billNeoDTO);
			}
		}

		return billNeoDTOs;
	}
}

