package com.diagbot.repository;

import com.diagbot.entity.node.LisName;
import org.springframework.data.neo4j.annotation.Query;
import org.springframework.data.neo4j.repository.Neo4jRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;


public interface LisNameRepository extends Neo4jRepository<LisName, Long> {

    List<LisName> findByNameIs(String name);

    List<LisName> findByNameContaining(String name);

    List<LisName> findByNameIn(List<String> names);

    @Query("MATCH (n:实验室检查名称)-[r]->(b) where n.name contains {name} or (EXISTS(n.拼音编码) AND n.拼音编码 CONTAINS {name}) return n.name, n.拼音编码,collect(r), collect(b) limit 100")
    List<LisName> findByNameOrPycodeContaininglimit100(@Param("name") String name);
}

