package com.diagbot.repository;

import com.diagbot.biz.push.entity.Item;
import com.diagbot.biz.push.entity.Lis;
import com.diagbot.dto.*;
import com.diagbot.entity.node.*;
import com.diagbot.model.label.PacsLabel;
import com.diagbot.util.NeoUtil;
import com.diagbot.util.StringUtil;
import com.diagbot.vo.CriticalNeoVO;

import java.math.BigDecimal;
import java.util.*;

public class PacsCriticalNode {


	/**
	 * 获取辅检危急值
	 */
	public List<CriticalNeoDTO> getPacsList(CriticalNeoVO criticalNeoVO, PacsCriticalRepository pacsCriticalRepository) {
		String result;
		Integer agemin, agemax;

		List<CriticalNeoDTO> criticallist = new ArrayList<>();
		CriticalNeoDTO criticalNeoDTO;

		Integer gender = criticalNeoVO.getSex();
		Integer age = criticalNeoVO.getAge();
		List<Item> pacsres = criticalNeoVO.getPacsLabel().getRes();

		try {
			for (Item item : pacsres) {

				String name = item.getUniqueName();

				if (StringUtil.isNotBlank(name)) {
					List<PacsCritical> pacslist = pacsCriticalRepository.findByResult(name);

					for (PacsCritical pacscri : pacslist) {
						criticalNeoDTO = new CriticalNeoDTO();
						result = pacscri.getVal();
						criticalNeoDTO.setName(result);
						criticalNeoDTO.setStandname(result);
						criticalNeoDTO.setType(Constants.fujian);

						criticallist.add(criticalNeoDTO);
					}
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		return criticallist;
	}


}

