package com.diagbot.repository;

import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.PacsBillNeoDTO;
import com.diagbot.entity.node.*;
import com.diagbot.util.NeoUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class PacsSubNameNode {


    public PacsBillNeoDTO PacstoPACSDTO(PacsSubName pacs) {
        PacsBillNeoDTO pacsBillNeoDTO = new PacsBillNeoDTO();
        NodeInfo nodeInfo;


        Set<Group> groups = pacs.getGroups();
        for (Group group : groups) {
            nodeInfo = new NodeInfo();
            nodeInfo.setName(group.getName());
            nodeInfo.setTypeval(Constants.group);
            pacsBillNeoDTO.getGroup().add(NeoUtil.updateNodeInfo(nodeInfo));
        }


        Set<Disease> diseases = pacs.getDiseases();
        for (Disease disease : diseases) {
            nodeInfo = new NodeInfo();
            nodeInfo.setName(disease.getName());
            nodeInfo.setTypeval(Constants.disease);
            pacsBillNeoDTO.getDisease().add(NeoUtil.updateNodeInfo(nodeInfo));
        }


        Set<MedAllergen> medAllergens = pacs.getMedallergens();
        for (MedAllergen medAllergen : medAllergens) {
            nodeInfo = new NodeInfo();
            nodeInfo.setName(medAllergen.getName());
            nodeInfo.setTypeval(Constants.medallergen);
            pacsBillNeoDTO.getOperations().add(NeoUtil.updateNodeInfo(nodeInfo));
        }


        return pacsBillNeoDTO;
    }


    /**
     * 处理辅检开单合理性
     */
    public List<BillNeoDTO> getPacsBill(Map<String, String> pacsterm, PacsSubNameRepository pacsRepository) {
        List<BillNeoDTO> billNeoDTOs = new ArrayList<>();
        BillNeoDTO billNeoDTO;

        PacsBillNeoDTO pacsBillNeoDTO;

        List<PacsSubName> pacslt;
        String pacsname;

        for (String term : pacsterm.keySet()) {
            billNeoDTO = new BillNeoDTO();
            pacsname = pacsterm.get(term);
            billNeoDTO.setName(term);
            billNeoDTO.setStandname(pacsname);

            pacsBillNeoDTO = new PacsBillNeoDTO();

            pacslt = pacsRepository.findByNameIs(pacsname);

            if (pacslt != null && pacslt.size()>0) {
                pacsBillNeoDTO = PacstoPACSDTO(pacslt.get(0));
            }

            billNeoDTO.setPacsBillNeoDTO(pacsBillNeoDTO);

            billNeoDTOs.add(billNeoDTO);
        }

        return billNeoDTOs;
    }


    /**
     * 获取辅检子项目名称列表
     */
    public List<String> getPACSSubNameList(String name, PacsSubNameRepository pacsRepository) {
        String pacsname;

        List<String> pacslist = new ArrayList<>();

        List<PacsSubName> pacslt = pacsRepository.findByNameContaining(name);

        for (PacsSubName pacs : pacslt) {
            pacsname = pacs.getName();
            if (!pacslist.contains(pacsname)) {
                pacslist.add(pacsname);
            }
        }


        return pacslist;
    }
}






