package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.MsgUtil;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @description: 年龄规则
 * @author: zhoutg
 * @time: 2020/8/3 14:47
 */
@Component
public class AgeRule {

    /**
     * 年龄比较
     *
     * @param wordCrfDTO
     * @param billNeoMaxDTO
     * @return
     */
    public void bill(WordCrfDTO wordCrfDTO, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        NodeNeoDTO ageNeoDTO = billNeoMaxDTO.getAgeNeoDTO();
        Boolean flag = false;
        if (ageNeoDTO != null && wordCrfDTO.getAge() != null) {
            Integer age = wordCrfDTO.getAge();
            flag = CoreUtil.compareNum(ageNeoDTO, age);
        }
        if (flag) {
            // String message = CoreUtil.getStrMsgWithRange(ageNeoDTO, "年龄", String.valueOf(wordCrfDTO.getAge()));
            String message = "年龄" + wordCrfDTO.getAge();
            BillMsg billMsg = MsgUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(), billNeoMaxDTO.getOrderStandName(),
                    message, type, billNeoMaxDTO.getType());
            billMsgList.add(billMsg);
        }
    }
}
