package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.util.MsgUtil;
import com.diagbot.util.StringUtil;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @description: 性别规则
 * @author: zhoutg
 * @time: 2020/8/3 14:47
 */
@Component
public class SexRule {

    /**
     * 比较性别
     *
     * @param wordCrfDTO
     * @param billNeoMaxDTO
     * @return
     */
    public void bill(WordCrfDTO wordCrfDTO, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        NodeNeoDTO nodeNeoDTO = billNeoMaxDTO.getGender();
        if (nodeNeoDTO != null && StringUtil.isNotBlank(nodeNeoDTO.getName()) && wordCrfDTO.getSex() != null) {
            String sex = nodeNeoDTO.getName();
            String sexStr = "";
            if (1 == wordCrfDTO.getSex()) {
                sexStr = "男性";
            } else if (2 == wordCrfDTO.getSex()) {
                sexStr = "女性";
            }
            if (sex.equals(sexStr)) {
                if ("男性".equals(sexStr)) {
                    BillMsg billMsg = MsgUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(), billNeoMaxDTO.getOrderStandName(),
                            "男性", type, billNeoMaxDTO.getType());
                    billMsgList.add(billMsg);
                } else if ("女性".equals(sexStr)) {
                    BillMsg billMsg = MsgUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(), billNeoMaxDTO.getOrderStandName(),
                            "女性", type, billNeoMaxDTO.getType());
                    billMsgList.add(billMsg);
                }
            }
        }
    }
}
