package com.diagbot.util;

import com.alibaba.fastjson.JSONObject;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.PushBaseDTO;
import com.diagbot.repository.Constants;
import com.diagbot.repository.NodeInfo;
import com.diagbot.repository.datautil;

import java.math.BigDecimal;

public class NeoUtil {

    private static String regex = "(.*)\\([a-zA-Z0-9]+\\)";

    public static NodeNeoDTO updateNodeInfo(NodeInfo nodeInfo) {
        NodeNeoDTO nodeNeoDTO = new NodeNeoDTO();

        String name = nodeInfo.getName();
        name = (null==name)?"":name;
        name = datautil.removekey(name, Constants.conflict);
        nodeNeoDTO.setName(name);

        BigDecimal min = nodeInfo.getMinval();
        if (null!=min) {
            nodeNeoDTO.setMin(min);
        }

        BigDecimal max = nodeInfo.getMaxval();
        if (null!=max) {
            nodeNeoDTO.setMax(max);
        }

        String unit = nodeInfo.getUnit();
        unit = (null==unit)?"":unit;
        nodeNeoDTO.setUnit(unit);

        Integer range = nodeInfo.getRange();
        range = (null==range)?0:range;
        nodeNeoDTO.setValType(range);

        String type = nodeInfo.getTypeval();
        type = (null==type)?"":type;
        nodeNeoDTO.setTermtype(type);

        return nodeNeoDTO;
    }




    public static PushBaseDTO updatePushInfo(String name) {
        PushBaseDTO pushBaseDTO = new PushBaseDTO();

        name = (null==name)?"":name;
        pushBaseDTO.setName(name);

        return pushBaseDTO;
    }

    public static BigDecimal DoubletoBigDecimal(Double val) {
        BigDecimal bd = null;
        if (null!=val) {
            bd = new BigDecimal(val.toString());
        }

        return bd;
    }

    public static BigDecimal StringtoBigDecimal(String val) {
        BigDecimal bd = null;
        if (StringUtil.isNotBlank(val)) {
            bd = new BigDecimal(val);
        }

        return bd;
    }

    public static NodeNeoDTO jsontoNodeNeoDTO(String name, JSONObject jobj) {

        NodeNeoDTO nodeNeoDTO = null;
        try {
            nodeNeoDTO = new NodeNeoDTO();
            nodeNeoDTO.setName(name.trim());
            if (null!=jobj) {
                for (String key : jobj.keySet()) {
                    switch (key) {
                        case "最大值":
                            nodeNeoDTO.setMax(new BigDecimal(jobj.getString(key)));
                            break;
                        case "最小值":
                            nodeNeoDTO.setMin(new BigDecimal(jobj.getString(key)));
                            break;
                        case "单位":
                            nodeNeoDTO.setUnit(jobj.getString(key));
                            break;
                        case "范围":
                            nodeNeoDTO.setValType(jobj.getIntValue(key));
                            break;
                        case "结果":
                            nodeNeoDTO.setVal(jobj.getString(key));
                            break;
                    }
                }
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        finally {
            return nodeNeoDTO;
        }
    }


    public static String getMedType(String medname) {
        String medtype = Constants.yaoping;
        if (medname.matches(regex)) {
            medtype = Constants.yaopingleibie;
        }

        return medtype;
    }
}
